package re.jimmitry.apps974.furious;
import re.jimmitry.apps974.furious.*;
import java.sql.*;
import java.util.Properties;

public class FuriousCONNECTION_SYS {
        public static int TIMEOUT_VALID_CNX=getKERNEL();
	public Connection CNX = null;
	public boolean Libre = true;
	public boolean Valide = false;
	public String TypeCNX = "";
	public String Reservation = "";
	public String ErrorMessage = "";
        public long nbCall = 0;
        public int idpool = 0;
private static Connection NewAccessConnection(String PaDatabase, String PbUser, String PcPassword, String PgOption, String PhSeparator, String PfPremier) throws Exception  {
  Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
  String CNDatabaseCh = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ="+PaDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PbUser);
  Pi.setProperty("password", PcPassword);
  if (!PgOption.equals("")) {
    CNDatabaseCh+=PfPremier+PgOption;
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewAdvantageConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName ("com.extendedsystems.jdbc.advantage.ADSDriver");
  String CNDatabaseCh = "jdbc:extendedsystems:advantage://"+PaHost+":"+PbPort+";catalog="+PcDatabase+";user="+PdUser+";password="+PfPassword;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
public void NewCONNECTION(String PaTypeCNX, String PbHost, String PcPort, String PdDatabase, 
    String PeUser, String PgPassword, String PfOption, String PhSeparator, String PiPremier) throws Exception {
  if (PaTypeCNX.equals("H2FileDB")) {
    this.CNX = NewH2FileDBConnection(PdDatabase, PeUser, PgPassword, PfOption, PhSeparator, PiPremier);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("H2DB")) {
    this.CNX = NewH2DBConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("Oracle")) {
    this.CNX = NewOracleConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("DB2")) {
    this.CNX = NewDB2Connection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PiPremier);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("SQLServer")) {
    this.CNX = NewSQLServerConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("MySQL")) {
    this.CNX = NewMySQLConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("Advantage")) {
    this.CNX = NewAdvantageConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("PostgreSQL")) {
    this.CNX = NewPostgreSQLConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("MaxDB")) {
    this.CNX = NewMaxDBConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("Access")) {
    this.CNX = NewAccessConnection(PdDatabase, PeUser, PgPassword, PfOption, PhSeparator, PiPremier);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("Derby")) {
    this.CNX = NewDerbyConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("FireBird")) {
    this.CNX = NewFireBirdConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("McKoiFileDB")) {
    this.CNX = NewMcKoiFileDBConnection(PdDatabase, PeUser, PgPassword, PfOption, PhSeparator, PiPremier);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("McKoiDB")) {
    this.CNX = NewMcKoiDBConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("HSQLFileDB")) {
    this.CNX = NewHSQLFileDBConnection(PdDatabase, PeUser, PgPassword, PfOption, PhSeparator, PiPremier);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("HSQLDB")) {
    this.CNX = NewHSQLDBConnection(PbHost, PcPort, PdDatabase, PeUser, PgPassword, PfOption, PhSeparator);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  } else if (PaTypeCNX.equals("XML")) {
    this.CNX = NewXMLConnection(PdDatabase);
    this.TypeCNX = PaTypeCNX;
    this.nbCall=0;
  };
}
private static Connection NewDB2Connection(String PaHost, String PbPort, String PcDatabase, String PdUser, String PePassword, 
    String PfOption, String PgPremier) throws Exception {
  Class.forName("com.ibm.db2.jcc.DB2Driver");
  String CNDatabaseCh = "jdbc:db2://"+PaHost+":"+PbPort+"/"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PePassword);
  if (!PfOption.equals("")) {
    CNDatabaseCh+=PgPremier+PfOption;
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewDerbyConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName ("com.mysql.jdbc.Driver");
  String CNDatabaseCh = "jdbc:derby://"+PaHost+":"+PbPort+"/"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewFireBirdConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName ("org.firebirdsql.jdbc.FBDriver");
  String CNDatabaseCh = "jdbc:firebirdsql:"+PaHost+"/"+PbPort+":"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewH2DBConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName("org.h2.Driver");
  String CNDatabaseCh = "";
  CNDatabaseCh="jdbc:h2:tcp://"+PaHost+":"+PbPort+"/"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewH2FileDBConnection(String PaDatabase, String PbUser, String PcPassword, String PgOption, String PhSeparator, String PfPremier) throws Exception {
  Class.forName("org.h2.Driver");
  String CNDatabaseCh = "jdbc:h2:"+PaDatabase+";MULTI_THREADED=1;MVCC=FALSE";
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PbUser);
  Pi.setProperty("password", PcPassword);
  if (!PgOption.equals("")) {
    CNDatabaseCh+=PfPremier+PgOption;
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewHSQLDBConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName("org.hsqldb.jdbcDriver");
  String CNDatabaseCh = "jdbc:hsqldb:hsql://"+PaHost+":"+PbPort+"/"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewHSQLFileDBConnection(String PaDatabase, String PbUser, String PcPassword, String PgOption, String PhSeparator, String PfPremier) throws Exception {
  Class.forName("org.hsqldb.jdbcDriver");
  String CNDatabaseCh = "jdbc:hsqldb:file:"+PaDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PbUser);
  Pi.setProperty("password", PcPassword);
  if (!PgOption.equals("")) {
    CNDatabaseCh+=PfPremier+PgOption;
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewMaxDBConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName ("com.sap.dbtech.jdbc.DriverSapDB");
  String CNDatabaseCh = "jdbc:sapdb://"+PaHost+":"+PbPort+"/"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewMcKoiDBConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName("com.mckoi.JDBCDriver");
  String CNDatabaseCh = "jdbc:mckoi://"+PaHost+":"+PbPort+"/"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewMcKoiFileDBConnection(String PaDatabase, String PbUser, String PcPassword, String PgOption, String PhSeparator, String PfPremier) throws Exception {
  Class.forName("com.mckoi.JDBCDriver");
  String CNDatabaseCh = "jdbc:mckoi:local://"+PaDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PbUser);
  Pi.setProperty("password", PcPassword);
  if (!PgOption.equals("")) {
    CNDatabaseCh+=PfPremier+PgOption;
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}

private static Connection NewMySQLConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName ("com.mysql.jdbc.Driver");
  String CNDatabaseCh = "";
  if (PcDatabase.equals("dbsconnector")) 
	  CNDatabaseCh="jdbc:mysql://"+Fur_File.getINIinfos("PARAM.INI", "MYSQL_CONFIG", "N1HOST")+":"+Fur_File.getINIinfos("PARAM.INI", "MYSQL_CONFIG", "N1PORT")+"/dbsconnector";
  else 
	  CNDatabaseCh="jdbc:mysql://"+PaHost+":"+PbPort+"/"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  if (PcDatabase.equals("dbsconnector")) {
	  Pi.setProperty("user", Fur_File.getINIinfos("PARAM.INI", "MYSQL_CONFIG", "USER"));
	  Pi.setProperty("password", Fur_File.getINIinfos("PARAM.INI", "MYSQL_CONFIG", "PASSWORD"));
  } else {
	  Pi.setProperty("user", PdUser);
	  Pi.setProperty("password", PfPassword);
  }
  
  Pi.setProperty("allowMultiQueries", "true");
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private Connection NewOracleConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName ("oracle.jdbc.driver.OracleDriver");
  String CNDatabaseCh = "jdbc:oracle:thin:@"+PaHost+":"+PbPort+":"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewPostgreSQLConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName ("org.postgresql.Driver");
  String CNDatabaseCh = "jdbc:postgresql://"+PaHost+":"+PbPort+"/"+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewSQLServerConnection(String PaHost, String PbPort, String PcDatabase, 
    String PdUser, String PfPassword, String PgOption, String PhSeparator) throws Exception {
  Class.forName ("com.microsoft.sqlserver.jdbc.SQLServerDriver");
  String CNDatabaseCh = "jdbc:sqlserver://"+PaHost+":"+PbPort+";databaseName="+PcDatabase;
  DriverManager.setLoginTimeout(10);
  Properties Pi = new Properties();
  Pi.setProperty("user", PdUser);
  Pi.setProperty("password", PfPassword);
  if (!PgOption.equals("")) {
    for(int i=1;i<=Integer.parseInt(Fur_Atome.getSizeAtomeList(PgOption, PhSeparator));i++) {
      Pi.setProperty(Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "1", "="), Fur_Atome.getAtome(Fur_Atome.getAtome(PgOption, ""+i, PhSeparator), "2", "="));
    }
  }
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh, Pi);
  return MaConnexion;
}
private static Connection NewXMLConnection(String PaDatabase) throws Exception {
  Class.forName("com.rohanclan.ashpool.jdbc.Driver");
  String CNDatabaseCh = "jdbc:ashpool:file://"+PaDatabase;
  DriverManager.setLoginTimeout(10);
  Connection MaConnexion = DriverManager.getConnection(CNDatabaseCh);
  return MaConnexion;
}
public static String PINGSQL(String IDCN) {
  if (IDCN.equals("H2DB") || IDCN.equals("H2FileDB")) return "SELECT 1 from dual;";
  else if (IDCN.equals("Oracle")) return "SELECT 1 FROM DUAL";
  else if (IDCN.equals("DB2")) return "SELECT 1 FROM SYSIBM.SYSDUMMY1 FETCH FIRST 1 ROW ONLY";
  else if (IDCN.equals("SQLServer")) return "SELECT 1";
  else if (IDCN.equals("MySQL")) return "SELECT 1";
  else if (IDCN.equals("Advantage")) return "select 1 from system.iota";
  else if (IDCN.equals("PostgreSQL")) return "SELECT 1";
  else if (IDCN.equals("MaxDB")) return "SELECT 1 FROM DUAL";
  else if (IDCN.equals("Access")) return "SELECT 1";
  else if (IDCN.equals("Derby")) return "SELECT 1 FROM SYSIBM.SYSDUMMY1";
  else if (IDCN.equals("FireBird")) return "select 1 from RDB$DATABASE;";
  else if (IDCN.equals("McKoiDB") || IDCN.equals("McKoiFileDB")) return "SELECT 1;";
  else if (IDCN.equals("HSQLDB") || IDCN.equals("HSQLFileDB")) return "SELECT * from dual;";
  else if (IDCN.equals("XML")) return "SELECT TEST";
  else return "SELECT 1"; //if (IDCN.equals("MySQL")) 
}
public static int getKERNEL() {
  int retour=15000;
  try {
    retour=Integer.parseInt(Fur_File.getINIinfos("PARAM.INI", "DATABASE", "TIMEOUT_FOR_VALID_CONNECTION"));
  } catch (Exception e) {
    retour=15000;
  }
  return retour;
}
public static boolean isValidCNX(FuriousCONNECTION_SYS MyConnexion) throws Exception	{
  String SQL = "SELECT 1 from dual;";
  boolean b = true;
  Statement stm = null;
  ResultSet rs=null;
    try {
      //... AUTRE BASE
      stm = MyConnexion.CNX.createStatement();
FuriousCONNECTION_SYS_Thread thread = new FuriousCONNECTION_SYS_Thread(SQL, "H2DB", stm, rs);
thread.setPriority(java.lang.Thread.MAX_PRIORITY);
thread.start();
long endTimeMillis = System.currentTimeMillis() + TIMEOUT_VALID_CNX;
while (thread.isAlive()) {
	if (System.currentTimeMillis() > endTimeMillis) {
		break;
	}
	/*try {
		Thread.sleep(500);
	}
	catch (InterruptedException t) {}*/
}
  b=thread.b;
    thread.interrupt();
    } catch (Exception e) {
      b = false;
    } finally {
      try {rs.close();} catch (Exception f) {};
      try {stm.close();} catch (Exception g) {};
      /*if (!b && !(MyConnexion.CNX==null)) { Inutile car la connexion n'est plus valide ... en plus sa block ...
        try {MyConnexion.CNX.close();} catch (Exception h) {};
      }*/
    }
    //return false;
    MyConnexion.Valide=b;
    return b;
}
//Action: V?rifie si une connexion est toujours valide en testant une simple requete sql SELECT 1 from selon la database en cours ...
//in:
//out: un boolean pour dire si notre connexion est toujours valide ou pas
//Exemple: this.isValide()
public boolean isValide() throws Exception	{
  String SQL = "";
  boolean b = true;
  Statement stm = null;
  ResultSet rs=null;
  if (!this.Valide) return false;
  else {
    try {
      SQL=PINGSQL(this.TypeCNX);
      //... AUTRE BASE
      stm = this.CNX.createStatement();
FuriousCONNECTION_SYS_Thread thread = new FuriousCONNECTION_SYS_Thread(SQL, TypeCNX, stm, rs);
thread.setPriority(java.lang.Thread.MAX_PRIORITY);
thread.start();
long endTimeMillis = System.currentTimeMillis() + TIMEOUT_VALID_CNX;
while (thread.isAlive()) {
	if (System.currentTimeMillis() > endTimeMillis) {
		break;
	}
	/*try {
		Thread.sleep(500);
	}
	catch (InterruptedException t) {}*/
}
  b=thread.b;
    thread.interrupt();
    } catch (Exception e) {
      b = false;
    } finally {
      try {rs.close();} catch (Exception f) {};
      try {stm.close();} catch (Exception g) {};
      /*if (!b && !(this.CNX==null)) { Inutile car la connexion n'est plus valide ... en plus sa block ...
        try {this.CNX.close();} catch (Exception h) {};
      }*/
    }
    //return false;
    return b;
  }
}
}
